# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

# FIXME: (dwalluck): disabling this option breaks the build
%bcond_without jdk6
%bcond_without jts
%bcond_with oracle
%bcond_without repolib
%bcond_with ws

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossts/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define cvsversion 4_6_1
%define namedcvsversion %{cvsversion}_%{reltag}
# Dont forget to update jbossts-build.patch as well
%define reltag GA
%define namedversion %{version}.%{reltag}

%global ant JAVA_HOME=%{java_home} %{_bindir}/ant17

Name:           jbossts
Version:        4.6.1
Release:        1%{?dist}
Epoch:          1
Summary:        JBoss Transaction Service
Group:          Development/Java
License:        LGPLv2+
URL:            http://labs.jboss.com/jbosstm/
# svn -q export http://anonsvn.jboss.org/repos/labs/labs/jbosstm/tags/JBOSSTS_4_6_1_GA/ jbossts-4.6.1 && tar cjf jbossts-4.6.1.tar.bz2 jbossts-4.6.1
Source0:        jbossts-4.6.1.tar.bz2
Source1:        jbossts-component-info.xml
Patch0:         jbossts-build.patch
Patch1:         jbossts-disable-tests.patch
Patch2:         jbossts-jdbc.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant17
BuildRequires:  ant17-nodeps
BuildRequires:  ant17-junit
BuildRequires:  ant17-trax
BuildRequires:  concurrent
BuildRequires:  j2ee-connector
BuildRequires:  jakarta-commons-logging
BuildRequires:  jboss-dtf
BuildRequires:  jcommon
BuildRequires:  jfreechart
BuildRequires:  jta
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  mx4j
BuildRequires:  tanukiwrapper
BuildRequires:  xerces-j2
%if %with jts
BuildRequires:  antlr
BuildRequires:  avalon-logkit
BuildRequires:  avalon-framework
BuildRequires:  jacorb-jboss
BuildRequires:  picocontainer
%endif
%if %with ws
BuildRequires:  bea-stax
BuildRequires:  servletapi_2_4_api
BuildRequires:  saaj
BuildRequires:  jaxrpc
BuildRequires:  wstx
%endif
# For testing (localjunit)
BuildRequires:  jakarta-commons-codec
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
# Maven is just used to deply artifacts
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
# ATS integration
BuildRequires:  jboss5-libs
BuildRequires:  jboss-bootstrap
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-integration
BuildRequires:  jbosssx2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Reliable Java and Web Services transaction management.
Includes Arjuna Transaction Service Suite (ArjunaTS) and
Arjuna's Web Services Transaction implementation, the market's only
implementation supporting both leading web services specifications
Web Services Transaction (WS-TX) and Web Services Composite Application
Framework (WS-CAF)

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q
chmod -R go=u-w *

perl -pi -e 's/ant-launcher\.jar/ant17-launcher.jar/g;' build.xml

# Specify target 1.5 for all compilations
perl -p -i -e 's/<javac/<javac source="1.5" target="1.5"/' `find . -name '*build*.xml' -print`

# FIXME: remove classes12.jar which is Oracle's proprietary
# FIXME: Where do we get this Arjuna's TestingFramework.jar ?
find -type f -name "*.jar" \
%if %with oracle
       -not -name "classes12.jar" \
%endif
%if 0
       -not -name "TestingFramework.jar" \
%endif
       | %{_bindir}/xargs -t %{__rm}

%if %without oracle
rm ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/objectstore/jdbc/oracle_driver.java
rm ArjunaJTA/jdbc/classes/com/arjuna/ats/internal/jdbc/drivers/modifiers/oracle_jndi.java
rm ArjunaJTA/jdbc/classes/com/arjuna/ats/internal/jdbc/recovery/OracleXARecovery.java
rm ArjunaJTA/jdbc/tests/classes/com/hp/mwtests/ts/jdbc/utils/plugins/OracleDataSourcePlugin.java
%endif

pushd ext
build-jar-repository . jmxri
build-jar-repository . jndi
build-jar-repository . jta
build-jar-repository . jdbc-stdext
build-jar-repository . commons-logging
build-jar-repository . tanukiwrapper
build-jar-repository . j2ee-connector
build-jar-repository . concurrent
build-jar-repository . log4j
# FIXME the ones below were supposed to be under ArjunaCore/tsmx/lib/ext but
# there they are not found, so moved them here
build-jar-repository . jcommon
build-jar-repository . jfreechart
build-jar-repository . jboss-dtf/TestingFramework
popd
pushd antbuildsystem/lib/ext
build-jar-repository . xerces-j2
popd
pushd common/lib/ext
build-jar-repository . xerces-j2
build-jar-repository . commons-logging
build-jar-repository . log4j
popd
#pushd ArjunaCore/tsmx/lib/ext
#build-jar-repository . jcommon
#build-jar-repository . jfreechart
#popd

%if %with jts
pushd ArjunaJTS/jacorb/lib
build-jar-repository . tanukiwrapper
build-jar-repository . antlr
build-jar-repository . avalon-framework
build-jar-repository . avalon-logkit
build-jar-repository . jacorb-jboss/jacorb
build-jar-repository . jacorb-jboss/idl
build-jar-repository . concurrent
build-jar-repository . picocontainer
#build-jar-repository . slf4j
popd
# For testing (localjunit)
pushd XTS/localjunit/ext
ln -s $(build-classpath commons-codec) commons-codec.jar
ln -s $(build-classpath commons-httpclient) commons-httpclient.jar
ln -s $(build-classpath commons-logging) commons-logging.jar
popd
%endif

%patch0 -p0
#The generation of unique identifiers for objects such as transactions 
# relies on the host's networking being correctly configured.
# So, disable these tests as they fail in brew
%patch1 -p0
%if %with jdk6
%patch2 -p0
%endif

# Remove as it fails in JPP
rm ArjunaCore/arjuna/tests/classes/com/hp/mwtests/ts/arjuna/reaper/ReaperTestCase2.java

# Remove the ReaperTestCase3 as it hungs in Brew
rm ArjunaCore/arjuna/tests/classes/com/hp/mwtests/ts/arjuna/reaper/ReaperTestCase3.java

# FIXME: These tests fail on Brew (investigate)
rm ArjunaCore/arjuna/tests/classes/com/hp/mwtests/ts/arjuna/common/PersistenceUnitTest.java

# FIXME: These tests error if we don't add slf4j to the path but if we do
# they fail with  http://www.slf4j.org/codes.html#multiple_bindings
#rm -f ArjunaJTS/jtax/tests/classes/com/hp/mwtests/ts/jta/jts/lastresource/LastResourceAllowedTestCase.java
rm -r ArjunaJTS/jtax/tests/classes/com/hp/mwtests/ts/jta/jts

mkdir JBOSSTS_%{namedcvsversion}
cp -pr antbuildsystem ArjunaCore ArjunaJTA ArjunaJTS atsintegration build-release-pkgs.xml Build.txt build.xml common copyright.txt ext jboss JBossORG-EULA.txt qa XTS JBOSSTS_%{namedcvsversion}/

%build
export JBOSS_HOME=%{_datadir}/jbossas

export CLASSPATH=$(build-classpath jboss5-libs/server-jmx-adaptor-plugin jbosssx2/jbosssx jboss-common-logging-spi jboss-integration/jboss-transaction-spi jboss-common-core jboss-bootstrap jboss-integration/jboss-corba-ots-spi jboss5-libs/iiop jacorb-jboss)
##export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant17.d/{junit,nodeps,trax}`

%if 0
%{ant} -Dant.library.dir=%{_javadir} \
        -Djavac.debug=true \
        jbossjta
%if %with jts
%{ant} -Dant.library.dir=%{_javadir} \
        -f build-test.xml \
        -Djavac.debug=true \
        jbossjts
%endif
%endif

#pushd ..
TS_WORKDIR=`pwd`
#popd
%{ant} -Dant.library.dir=%{_javadir} \
        -f build-release-pkgs.xml \
        -Dworkdir=$TS_WORKDIR \
        -Djavac.debug=true \
        -Dbuild.sysclasspath=last \
        dist

%install
rm -rf $RPM_BUILD_ROOT

# ***FIXME!!!*** POMs iand resource.jar must be generated and installed
# outside of repolib as well
# POMs: <jhalliday> fnasser_home: build-release-pkgs.xml mvn-repository target generates them on the fly.
#pushd ..
TS_WORKDIR=`pwd`
#popd
%{ant} -Dant.library.dir=%{_javadir} \
        -f build-release-pkgs.xml \
        -Dworkdir=$TS_WORKDIR \
        -Dmvn.repodir=$RPM_BUILD_ROOT%{_javadir}/repository.jboss.com/maven2-brew \
        -Djavac.debug=true \
        mvn-repository

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
# The actual build is made in a copy produced by expanding the ZIPs created
# from the sources, so they are at:
pushd build/JBOSSTS_%{namedcvsversion}
install -p -m 0644 lib/jbossjts.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-%{version}.jar
%add_to_maven_depmap jboss.jbossts jbossjts %{namedversion} JPP/%{name} jbossjts
install -p -m 0644 lib/jbossjts-integration.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-integration-%{version}.jar
%add_to_maven_depmap jboss.jbossts jbossjts-integration %{namedversion} JPP/%{name} jbossjts-integration
install -p -m 0644 lib/jbossjts-jacorb.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-jacorb-%{version}.jar
%add_to_maven_depmap jboss.jbossts jbossjts-jacorb %{namedversion} JPP/%{name} jbossjts-jacorb
install -p -m 0644 lib/ext/jbossts-common.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossts-common-%{version}.jar
%add_to_maven_depmap jboss.jbossts jbossts-common %{namedversion} JPP/%{name} jbossts-common
install -p -m 0644 bin/jbossts-tools.sar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossts-tools-%{version}.sar
%add_to_maven_depmap jboss.jbossts jbossts-tools %{namedversion} JPP/%{name} jbossts-tools
install -p -m 0644 xts/sar/jbossxts.sar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossxts-%{version}.sar
%add_to_maven_depmap jboss.jbossts jbossxts %{namedversion} JPP/%{name} jbossxts
install -p -m 0644 xts/tests/jbossxts-tests.zip $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossxts-tests-%{version}.zip
%add_to_maven_depmap jboss.jbossts jbossxts-tests %{namedversion} JPP/%{name} jbossxts-tests

#if 0
# FIXME: We need to find the two different properties,
# the one for JTA and the one for JTS
# For now, we just copy the resources.jar produced by mvn-repository
# used for the repolib maven contents creation
# resources jar
mkdir -p tmp/resources
pushd tmp
install -p -m 0644 ../etc/jbossts-properties.xml resources/jbossts-properties.xml-forJTA
install -p -m 0644 ../etc/jbossts-properties.xml resources/jbossts-properties.xml-forJTS
%{jar} -cf jbossts-resources-%{version}.jar resources 
install -p -m 0644 jbossts-resources-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/resources-%{version}.jar
popd
rm -Rf tmp
%add_to_maven_depmap jboss.jbossts resources %{namedversion} JPP/%{name} resources
#endif

# FIXME: This should be done before not in the repolib code
# We just need to find how to get the JTA and the JTS specific properties
install -p -m 0644 \
        $RPM_BUILD_ROOT%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/resources/%{namedversion}/resources-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/resources-%{version}.jar
%add_to_maven_depmap jboss.jbossts resources %{namedversion} JPP/%{name} resources

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar | sed "s|-%{version}||g"`; done)

mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossjts/%{namedversion}/jbossjts-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossjts.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossjts-integration/%{namedversion}/jbossjts-integration-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossjts-integration.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossjts-jacorb/%{namedversion}/jbossjts-jacorb-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossjts-jacorb.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossts-common/%{namedversion}/jbossts-common-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossts-common.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossts-tools/%{namedversion}/jbossts-tools-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossts-tools.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossxts/%{namedversion}/jbossxts-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossxts.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/jbossxts-tests/%{namedversion}/jbossxts-tests-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jbossxts-tests.pom
cp -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jboss/jbossts/resources/%{namedversion}/resources-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-resources.pom

%if %without repolib
rm -f $RPM_BUILD_ROOT%{_javadir}/repository.jboss.com
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr htdocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
popd

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}/resources
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{namedversion}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
%if %with jdk6
install -p -m 644 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
%endif
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossts-common-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jbossts-common.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jbossjts.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-integration-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jbossjts-integration.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjts-jacorb-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jbossjts-jacorb.jar
cp -p build/JBOSSTS_%{namedcvsversion}/etc/jbossts-properties.xml $RPM_BUILD_ROOT%{repodir}/resources/jbossts-properties.xml
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/jbossjts-%{version}.jar
%{_javadir}/%{name}/jbossjts-integration-%{version}.jar
%{_javadir}/%{name}/jbossjts-integration.jar
%{_javadir}/%{name}/jbossjts-jacorb-%{version}.jar
%{_javadir}/%{name}/jbossjts-jacorb.jar
%{_javadir}/%{name}/jbossjts.jar
%{_javadir}/%{name}/jbossts-common-%{version}.jar
%{_javadir}/%{name}/jbossts-common.jar
%{_javadir}/%{name}/jbossts-tools-%{version}.sar
%{_javadir}/%{name}/jbossts-tools.sar
%{_javadir}/%{name}/jbossxts-%{version}.sar
%{_javadir}/%{name}/jbossxts.sar
%{_javadir}/%{name}/jbossxts-tests-%{version}.zip
%{_javadir}/%{name}/jbossxts-tests.zip
%{_javadir}/%{name}/resources-%{version}.jar
%{_javadir}/%{name}/resources.jar
%{_datadir}/maven2/poms/JPP.%{name}-jbossjts.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossjts-integration.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossjts-jacorb.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossts-common.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossts-tools.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossxts.pom
%{_datadir}/maven2/poms/JPP.%{name}-jbossxts-tests.pom
%{_datadir}/maven2/poms/JPP.%{name}-resources.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Fri Mar 05 2010 David Walluck <dwalluck@redhat.com> 1:4.6.1-1
- rebase off of jbossts-4.6.1-2.CP04.3 brew version
- fix to build inside rpm build tree
- add missing jbossxts-tests.zip
- add missing poms
- always create maven repo even without repolib
- version sar files
